{_________________________________________
|  LOOKING FOR A JOB
|
| The author is currently available for employment.
| Please forward enquiries in this regard to the
| below e-mail address. Preferred destinations in
| the following order: United States, United Kingdom, Australia.
| Other destinations will be considered.
|
|_________________________________________}

(*
 *  TTAPILine component version 1.4
 *  (c)1998 Jury Kornienko
 *  j.kornienko@pf.lv
 *
 *
 *  See for updates in
 *  http://www.pf.lv/Delphi
 *
 *  TAPI.pas - Translated by Alexander Staubo
 *
 *  Source code provided under some conditions:
 *
 *  - if you use significant parts of the code, please credit me
 *  - do not release a new version of this component without
 *    significant enhancements
 *  - you have to send me all component improvements too
 *
 * Revision History
 * ----------------
 * TAPILine 1.0 - 1.02
 * 11.04.98 - first release
 * 29.04.98 - eventCallInProcess has been handled via Windows functions
 *            beacase of Delphi 2.0 doesn't have TEvent class...
 * 11.05.98 - new method added:
 *            - WriteLargeData (buffer: PChar, WantedToWrite: LONG) -
 *            allows read WantedToWrite data amount to PChar buffer;
 *            - procedure Write corrected;
 *            The folowing "bug" has been fixed (procedures Write
 *            and WriteLargeData ):
 *            sometimes application hangs up. In Delphi debugger GPF
 *            occures in very "harmless" place. For example
 *            count := count + 1;
 *            or something like this.
 *
 * TAPILine 1.4
 * 09.08.98 - (OnNewData event)under society high pressure OnNewData event
 *             has been added. To generate this event TAPILine creates child
 *             thread (single way how to do it). The main event
 *             code is situated in it. In the same time OnNewDataEvent user
 *             procedure will be called from PARENT thread. This event
 *             arrives a cople of times for each Read operation, therefore
 *             application should check this situation. How to use it please
 *             read in readme.txt.
 *             Idea by Mike Speer and other Delphi Developers.
 *          -  procedure WriteLargeData.
 *          -  procedures Read, ReadLargeData and Write has been completely
 *             redesigned again. Read and Write procedures has been implemented
 *             via XXXXXLargeData procedures accordingly.
 *          -  function cbInQue has been added. It returns count bytes in receive
 *             buffer. One Bill Gates company's "bug" (W95 only) has been found:
 *             if line has NOT been opened, but we try to access it via
 *             DirectDeviceAccess this function returns something like 4,500,000 B
 *             count (!?). Of course, may be function ClearCommError is not guilty,
 *             but...
 *          -  GetIcon corrected.
 *          -  new nice .avi for dial dialog.
 *          -  New Class TLogFile.
 *          -  MakeCall function has been corrected.
 *          -  not necessary to restart W'95 if some of TAPI function fail (I just want
 *             to tell that sentence "You are running under W'95 - shutdown is
 *             recomended." has been removed).
 *          -  property CountryCode has been removed
 *
 * 11.08.98 -  The following really serious bug has been fixed
 *             (for all TAPILine versions): sometimes OnConnection event arrives
 *             TWO times (therefore DirectDeviceAccess was performed two
 *             times too). In TAPI documentation is written that this event
 *             can arrives two (or more) times and application should check
 *             may be it already connected. Every time I knew about it, but for
 *             some strange reason in previous component versions I've
 *             implemented this routine for OnConnectionInt+ernal
 *             function only.
 *
 ****)
 // You have to specify this define if you have DELPHI 3
{$DEFINE DELPHI3}
unit TAPILine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tapi, ComCtrls, ExtCtrls, dsgnintf;

const
  TL_TIMEOUT = 20; // sec.
  HiVer = $00020000;  // Highest API version wanted (2.0)
  LoVer = $00010004;  // Lowest API version accepted (1.4)
  EVENT_TIMEOUT = 300;
  NEW_LINE = Chr (13)+Chr (10);
  CM_NEWDATATHREAD = WM_USER+777;
  CM_NEWDATAARRIVES = WM_USER+778;

//Reasons why a line device might not be usable by TapiComm.
  LINENOTUSEABLE_ERROR            =1;
  LINENOTUSEABLE_NOVOICE          =2;
  LINENOTUSEABLE_NODATAMODEM      =3;
  LINENOTUSEABLE_NOMAKECALL       =4;
  LINENOTUSEABLE_ALLOCATED        =5;
  LINENOTUSEABLE_INUSE            =6;
  LINENOTUSEABLE_NOCOMMDATAMODEM  =7;

  HEAP_ZERO_MEMORY = $00000008;

const
    LINEUNAVAIL = 'Line Unavailable';
    LINEUNNAMED = 'Line Unnamed';
    LINENAMEEMPTY = 'Line Name is Empty';

type

  TAboutTAPILineProperty = class(TPropertyEditor)
  public
  	procedure Edit; override;
  	function GetAttributes: TPropertyAttributes; override;
  	function GetValue: string; override;
  end;

  TformDialing = class(TForm)
    bHangUp: TButton;
    ModemName: TLabel;
    Image: TImage;
    procedure bHangUpClick(Sender: TObject);
  private
    { Private declarations }
    procedure CMNewData (var Message: TMessage); message CM_NEWDATATHREAD;
    procedure CMNewDataArrives (var Message: TMessage); message CM_NEWDATAARRIVES;
  public
    { Public declarations }
{$IFDEF DELPHI3}
    Animate: TAnimate;
{$ENDIF}
  end;

  TTAPILine = class(TComponent)
  private
    { Private declarations }
    FAbout: TAboutTAPILineProperty;
    FDirectAccessLogFile: string;{file name}
    FDirectAccessScript: TStrings;
    FDirectAccess: boolean;
    sDirectAccessResult: string;
    FTimeout: DWORD;

    FOnDisconnect: TNotifyEvent;
    FOnBusy: TNotifyEvent;
    FOnConnection: TNotifyEvent;
    FOnCallAnswering: TNotifyEvent;
    FOnOpen: TNotifyEvent;
    FOnClose: TNotifyEvent;
    FOnDropCall: TNotifyEvent;
    FOnUnexpectedClose: TNotifyEvent;
    FOnNewData: TNotifyEvent;

    LineApp : HLINEAPP;

    FPhoneNumber: string;
    FDevIDToInitialize: DWORD;
    FWaitForCall: boolean;

    anotherData: string;
    Parent: TComponent;
    eventCallInProcess: THANDLE;
    eventOverlappedWrite: THANDLE;
    eventOverlappedRead: THANDLE;
    FOnCallOffering: TNotifyEvent;{call in}
    dwRequestAnswer: DWORD;
    dwRequestMakeCall: DWORD;
    dwRequestDrop: DWORD;
    Procedure OnConnectionInt;
    procedure SetPhoneNumber (value: String);
    procedure SetDevIDToInitialize (value: DWORD);
    function LineCallStateToStr (CallState : DWORD) : string;
    function LineCallStateInfoToStr (CallState, Info : DWORD) : string;
    procedure SetWaitForCall (value: boolean);
    function ClearCommErrorToStr (dwErrorFlags : DWORD) : string;
    procedure OnReply (dwParam1: DWORD; dwErrorCode: DWORD);
    function I_lineNegotiateLegacyAPIVersion (dwDeviceID: DWORD): DWORD;
    function I_lineNegotiateAPIVersion (dwDeviceID: DWORD): DWORD;
    procedure MakeDirectAccessScript;
    procedure SetLines (Value: TStrings);
    function GetLineName (lpLineDevCaps_: LPLINEDEVCAPS): string;
    procedure SetInfoLabel(Value: TStatusPanel);
  public
    { Public declarations }
    Line : HLINE;
    Call : HCALL;

    bDropped: boolean;
    Version : DWORD;
    NumDevs : Integer; {Number of TAPI devices}
    bConnected: boolean;
    InfoLabel: TStatusPanel;
    hCommFile: LONG;
    bStopWaitingNewData: boolean;
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ConfigDialog;
    function Drop: boolean;
    function MakeCall: boolean;
    procedure Open;
    function Write (const sData: String): Boolean;
    function Read(wantedToRead: DWORD):string;
    function ReadLargeData (buffer: PChar; wantedToRead: DWORD):LONG;
    procedure Close;
    procedure TranslateDialog;
    function GetIcon (DevID: DWORD): HICON;
    function FillTAPILine (sl: TStrings): DWORD;
    function VerifyUsableLine (dwDeviceID: DWORD): LONG;
    function WriteLargeData (const buffer: PChar; wantedToWrite: DWORD): Boolean;
    function cbInQue:longint;
    procedure SetTimeout (Value: longint);
    procedure ResumeWaitingNewData;
  published
    property About: TAboutTAPILineProperty read FAbout write FAbout;
    property WaitForCall: boolean read FWaitForCall write FWaitForCall;
    property DeviceDirectAccess: boolean read FDirectAccess write FDirectAccess;
    property PhoneNumber: string read FPhoneNumber write SetPhoneNumber;
    property DevIdToInitialize: DWORD read FDevIdToInitialize write SetDevIdToInitialize;
    property DirectAccessScript: TStrings read FDirectAccessScript write SetLines;
    property DirectAccessLogFile: string read FDirectAccessLogFile write FDirectAccessLogFile;
    property Timeout: DWORD read FTimeout write FTimeout;

    property OnConnection: TNotifyEvent read FOnConnection write FOnConnection;
    property OnCallOffering: TNotifyEvent read FOnCallOffering write FOnCallOffering;
    property OnCallAnswering: TNotifyEvent read FOnCallAnswering write FOnCallAnswering;
    property OnDisconnect: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property OnBusy: TNotifyEvent read FOnBusy write FOnBusy;
    property OnOpen: TNotifyEvent read FOnOpen write FOnOpen;
    property OnClose: TNotifyEvent read FOnClose write FOnClose;
    property OnDropCall: TNotifyEvent read FOnDropCall write FOnDropCall;
    property OnUnexpectedClose: TNotifyEvent read FOnUnexpectedClose write FOnUnexpectedClose;
    property OnNewData: TNotifyEvent read FOnNewData write FOnNewData;
  end;

  TNewData = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

  TLogFile = class(TComponent)
  private
    { Private declarations }
    slLogFile: TStringList;
  public
    { Public declarations }
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteLog (tag: string; responce: string);
    procedure SaveToFile (sfile: string);
  published
    { no properties }
  end;

   procedure LineCallbackProc (hDevice,
                            dwMessage,
                            dwInstance,
                            dwParam1,
                            dwParam2,
                            dwParam3 : DWORD); stdcall;

   procedure ZeroMem (p: PChar);
   procedure Register;

   Var
      thisTAPILine: TTAPILine;
      formDialing: TformDialing;
      thread: TNewData;
      bWaitingInProcess: boolean;

implementation

{$R *.DFM}

{$R TLine2.res}

{
Register the component with the Delphi IDE
}
procedure Register;
begin
    RegisterComponents('Freeware', [TTAPILine]);
    RegisterPropertyEditor(TypeInfo(TAboutTAPILineProperty), TTAPILine, 'ABOUT', TAboutTAPILineProperty);
end;

(*
 * About property
 *)
procedure TAboutTAPILineProperty.Edit;
begin
    Application.MessageBox ('This component is freeware. (c) 1998 Juri Kornienko',
       			    'TTAPILine component version 1.4', MB_OK or MB_ICONINFORMATION);
end;

function TAboutTAPILineProperty.GetAttributes: TPropertyAttributes;
begin
    Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutTAPILineProperty.GetValue: string;
begin
    Result := '(about)';
end;

(*
 * TAPILine
 *)
function TTAPILine.LineCallStateToStr (CallState : DWORD) : string;
begin
  case CallState of
    LINECALLSTATE_IDLE :
      Result:='IDLE';
    LINECALLSTATE_OFFERING :
      Result:='OFFERING';
    LINECALLSTATE_ACCEPTED :
      Result:='ACCEPTED';
    LINECALLSTATE_DIALTONE :
      Result:='DIALTONE';
    LINECALLSTATE_DIALING :
      Result:='DIALING';
    LINECALLSTATE_RINGBACK :
      Result:='RINGBACK';
    LINECALLSTATE_BUSY :
      Result:='BUSY';
    LINECALLSTATE_SPECIALINFO :
      Result:='SPECIALINFO';
    LINECALLSTATE_CONNECTED :
      Result:='CONNECTED';
    LINECALLSTATE_PROCEEDING :
      Result:='PROCEEDING';
    LINECALLSTATE_ONHOLD :
      Result:='ONHOLD';
    LINECALLSTATE_CONFERENCED :
      Result:='CONFERENCED';
    LINECALLSTATE_ONHOLDPENDCONF :
      Result:='ONHOLDPENDCONF';
    LINECALLSTATE_ONHOLDPENDTRANSFER :
      Result:='ONHOLDPENDTRANSFER';
    LINECALLSTATE_DISCONNECTED :
      Result:='DISCONNECTED';
    LINECALLSTATE_UNKNOWN :
      Result:='UNKNOWN';
  else
    Result:='Unknown (' + IntTostr(CallState) + ')';
  end;
end;

function TTAPILine.LineCallStateInfoToStr (CallState, Info : DWORD) : string;
begin
  Result:='';
  if Info = 0 Then
     Result:='Command complete';
  case CallState of
    LINECALLSTATE_DIALTONE :
      case Info of
        LINEDIALTONEMODE_NORMAL :
          Result:='Dialtone normal';
        LINEDIALTONEMODE_SPECIAL :
          Result:='SPECIAL';
        LINEDIALTONEMODE_INTERNAL :
          Result:='INTERNAL';
        LINEDIALTONEMODE_EXTERNAL :
          Result:='EXTERNAL';
        LINEDIALTONEMODE_UNKNOWN :
          Result:='UNKNOWN';
        LINEDIALTONEMODE_UNAVAIL :
          Result:='UNAVAIL';
      end;
    LINECALLSTATE_BUSY :
      case Info of
        LINEBUSYMODE_sTATION :
          Result:='STATION';
        LINEBUSYMODE_TRUNK :
          Result:='TRUNK';
        LINEBUSYMODE_UNKNOWN :
          Result:='UNKNOWN';
        LINEBUSYMODE_UNAVAIL :
          Result:='UNAVAIL';
      end;
    LINECALLSTATE_DISCONNECTED :
      case Info of
        LINEDISCONNECTMODE_NORMAL :
          Result:='NORMAL';
        LINEDISCONNECTMODE_UNKNOWN :
          Result:='UNKNOWN';
        LINEDISCONNECTMODE_REJECT :
          Result:='REJECT';
        LINEDISCONNECTMODE_PICKUP :
          Result:='PICKUP';
        LINEDISCONNECTMODE_FORWARDED :
          Result:='FORWARDED';
        LINEDISCONNECTMODE_BUSY :
          Result:='BUSY';
        LINEDISCONNECTMODE_NOANSWER :
          Result:='NOANSWER';
        LINEDISCONNECTMODE_BADADDRESS :
          Result:='BADADDRESS';
        LINEDISCONNECTMODE_UNREACHABLE :
          Result:='UNREACHABLE';
        LINEDISCONNECTMODE_CONGESTION :
          Result:='CONGESTION';
        LINEDISCONNECTMODE_INCOMPATIBLE :
          Result:='INCOMPATIBLE';
        LINEDISCONNECTMODE_UNAVAIL :
          Result:='UNAVAIL';
        LINEDISCONNECTMODE_NODIALTONE:      // TAPI v1.4
          Result:='NODIALTONE';
      end;
  end;
  if Result = '' then
    Result:='Undefined (' + IntToStr(Info) + ')';
end;

procedure LineCallbackProc (hDevice,
                            dwMessage,
                            dwInstance,
                            dwParam1,
                            dwParam2,
                            dwParam3 : DWORD); stdcall; far;
var
  S : string;
begin
  case dwMessage of
       LINE_CLOSE:
           Begin
           S := 'Line has been unexpectedly closed';
           if Assigned (thisTAPILine.OnUnexpectedClose) Then thisTAPILine.OnUnexpectedClose (thisTAPILine);
           End;

       LINE_CALLSTATE:
           Begin
           S := thisTAPILine.LineCallStateInfoToStr (dwParam1, dwParam2);

           case dwParam1 of
                LINECALLSTATE_CONNECTED: // CONNECTED!!!
                  Begin
                  if (not thisTAPILine.bDropped) and (thisTAPILine.DevIDToInitialize <> MAXDWORD)
                     and (not thisTAPILine.bConnected) Then
                     Begin
                     try
                        thisTAPILine.OnConnectionInt;
                     except
                        ShowMessage ('An error occured on connection internal.');
                        formDialing.Hide;
                        exit;
                     end;

                     { Perform a direct access to device}
                     if (thisTAPILine.FDirectAccess) and
                         (thisTAPILine.FDirectAccessScript.Count <> 0) then
                         try
                            thisTAPILine.MakeDirectAccessScript;
                         except
                            ShowMessage (thisTAPILine.sDirectAccessResult);
                            formDialing.Hide;
                            exit;
                         End;

                     formDialing.Hide;

                     if Assigned (thisTAPILine.OnConnection) Then thisTAPILine.OnConnection (thisTAPILine);
                     End;
                  End;
                LINECALLSTATE_OFFERING:
                  if not thisTAPILine.bConnected then
                     Begin
                     thisTAPILine.Call := HCALL (hDevice);
                     if Assigned (thisTAPILine.OnCallOffering) Then thisTAPILine.OnCallOffering (thisTAPILine);
                     if thisTAPILine.FWaitForCall then
                        Begin
                        formDialing.Show;
                        try
                           TapiCheck(lineAnswer(thisTAPILine.Call, nil, 0));
                        except
                           ShowMessage ('Unable to answer to call.');
                           formDialing.Hide;
                           exit;
                        end;
                        End;
                     End;

                LINECALLSTATE_IDLE:
                  Begin
                  try
                     if thisTAPILine.Call.unused <> 0 Then
                        TapiCheck(lineDeallocateCall (thisTAPILine.Call));
                  except
                     ShowMessage ('Unable to dealocate a call.');
                     formDialing.Hide;
                     exit;
                  end;

                  thisTAPILine.Call.unused := 0;
                  CloseHandle (thisTAPILine.hCommFile);
                  thisTAPILine.hCommFile := INVALID_HANDLE_VALUE;
                  End;

                LINECALLSTATE_DISCONNECTED:
                  Begin
                  CloseHandle (thisTAPILine.hCommFile);
                  thisTAPILine.hCommFile := INVALID_HANDLE_VALUE;
                  if Assigned (thisTAPILine.OnDisconnect) Then thisTAPILine.OnDisconnect (thisTAPILine);
                  formDialing.Hide;
                  End;

                LINECALLSTATE_BUSY:
                  Begin
                  if Assigned (thisTAPILine.OnBusy) Then thisTAPILine.OnBusy (thisTAPILine);
                  formDialing.Hide;
                  End;
           else
                S := thisTAPILine.LineCallStateToStr (dwParam1);
           end;
           End;
    LINE_REPLY :
                     try
                        thisTAPILine.OnReply (dwParam1, dwParam2);
                     except
                        ShowMessage ('An error occured on reply.');
                        formDialing.Hide;
                        exit;
                     end;

  end;

  if Assigned (thisTAPILine.InfoLabel) and
     (S <> '') then
     thisTAPILine.InfoLabel.Text := S;
end;

procedure TTAPILine.OnReply (dwParam1: DWORD; dwErrorCode: DWORD);
Begin
    if dwParam1 = dwRequestAnswer Then
       Begin
       dwRequestAnswer := 0;
       TapiCheck (dwErrorCode);
       if Assigned (OnCallAnswering) Then OnCallAnswering (self);
       End;

    if dwParam1 = dwRequestMakeCall Then
       Begin
//       if Assigned (dwRequestMakeCall) Then dwRequestMakeCall (self);
       dwRequestMakeCall := 0;
       TapiCheck (dwErrorCode);
       End;

    if dwParam1 = dwRequestDrop Then
       Begin
       dwRequestAnswer := 0;
       dwRequestMakeCall := 0;
       dwRequestDrop := 0;
       formDialing.Hide;
       TapiCheck (dwErrorCode);
//       if Assigned (dwRequestMakeCall) Then dwRequestMakeCall (self);
       End;
End;

function TTAPILine.MakeCall: boolean;
var
  LineCallParams : TLINECALLPARAMS;

begin

  if DevIdToInitialize = MAXDWORD Then
     raise Exception.Create ('TAPILine: You must select TAPI compatible line');

  if Line.unused = 0 Then
     raise Exception.Create ('TAPILine: You must open line at first');

  Result := False;

  if dwRequestMakeCall > 0 Then
     exit;

  formDialing.Show;

  FillChar(LineCallParams, SizeOf(LineCallParams), 0);
  with LineCallParams do
    begin
      dwTotalSize:=SizeOf(LineCallParams);
      if FDirectAccess then
         dwBearerMode:=LINEBEARERMODE_PASSTHROUGH
      else
         dwBearerMode:=LINEBEARERMODE_VOICE;
      dwMediaMode:=LINEMEDIAMODE_DATAMODEM;
    end;

  bDropped := False;
  if FDirectAccess then
     dwRequestMakeCall := lineMakeCall(Line, @Call, nil, 0, @LineCallParams)
  else
     dwRequestMakeCall := lineMakeCall(Line, @Call, PChar(FPhoneNumber), 0, @LineCallParams);
  TapiCheck (dwRequestMakeCall);

  Result := True;
end;

destructor TTAPILine.Destroy;
begin
  try
     Drop;
     Close;
  except
  end;

  TapiCheck(lineShutdown(LineApp));

  CloseHandle (eventCallInProcess);
  CloseHandle (eventOverlappedWrite);
  CloseHandle (eventOverlappedRead);

  {$IFDEF DELPHI3}
  formDialing.Animate.Free; 
  {$ENDIF }

  thisTAPILine := nil;
  inherited Destroy;
end;

constructor TTAPILine.Create(AOwner: TComponent);
Var
	s: string;
begin
  inherited Create(AOwner);

  if thisTAPILine <> nil then
     raise Exception.Create('TAPILine component already exists in this process.');

  TapiCheck(lineInitialize(@LineApp,
                           GetModuleHandle (nil),
                           LineCallbackProc,
                           PChar (Application.Title),
                           @NumDevs));

  Version:=0;

  if NumDevs = 0 Then
     ShowMessage ('There is no modem installed in your PC.'+#13+#10+
                  'You should install it via Control panel | Modems | Add.');

  FDevIdToInitialize := MAXDWORD;
  FWaitForCall := True;

  InfoLabel := nil;
  Timeout := TL_TIMEOUT;
  Parent := AOwner;
  thisTAPILine := self;
  eventCallInProcess := CreateEvent (nil, True, True, nil);
  eventOverlappedWrite := CreateEvent (nil, True, True, nil);
  eventOverlappedRead := CreateEvent (nil, True, True, nil);
  bStopWaitingNewData := False;

  hCommFile := INVALID_HANDLE_VALUE;

  if formDialing = nil Then
     formDialing := TformDialing.Create (thisTAPILine);

  s:=ExtractFileDir (Application.ExeName);
  if s[Length (s)] <> '\' Then
     s := s + '\';

  if not (csDesigning in ComponentState) Then
     Begin
{$IFDEF DELPHI3}
     formDialing.Animate := TAnimate.Create (formDialing);
     formDialing.Animate.Parent := formDialing;
     formDialing.Animate.Left := 20;
     formDialing.Animate.Top := 14;
     formDialing.Animate.Width := 80;
     formDialing.Animate.Height := 75;
     formDialing.Animate.Active := False;
     formDialing.Animate.StopFrame := 6;

     try
        formDialing.Animate.FileName := s + 'TAPILine.avi';
        formDialing.Animate.Active := True;
     except
        on Exception do
           Begin
           ShowMessage ('Unable to open TAPILine.avi');
           formDialing.Animate.Visible := False;
{$ENDIF}
           formDialing.Image.Visible := True;
{$IFDEF DELPHI3}
           End;
     end;
{$ENDIF }
     End;

  FDirectAccess := False;
  FDirectAccessScript := TStringList.Create;
End;

procedure TTAPILine.Open;
var
  Ext : TLINEEXTENSIONID;
Begin
  if DevIdToInitialize = MAXDWORD Then
     raise Exception.Create ('TAPILine: You must select TAPI compatible line');

  if Assigned (thisTAPILine.InfoLabel) Then thisTAPILine.InfoLabel.Text := 'Try to open line... (takes several seconds)';

  Version:=0;

  TapiCheck (lineNegotiateAPIVersion(LineApp, DevIdToInitialize,
             LoVer, HiVer, @Version, @Ext));

  TapiCheck (lineOpen (LineApp, DevIdToInitialize, @Line, Version, 0, 0,
             LINECALLPRIVILEGE_MONITOR or LINECALLPRIVILEGE_OWNER, LINEMEDIAMODE_DATAMODEM, nil));

  if Assigned (thisTAPILine.InfoLabel) then
     thisTAPILine.InfoLabel.Text := 'Line opened';

  bDropped := False;
  bStopWaitingNewData := False;
  bWaitingInProcess := False;

//  if Thread <> nil Then
  //   Thread.Free;
  Thread := nil;

  if Assigned (FOnOpen) Then FOnOpen (self);
end;

procedure TTAPILine.ConfigDialog;
begin
  if DevIdToInitialize = MAXDWORD Then
     raise Exception.Create ('TAPILine: You must select TAPI compatible line');

  TapiCheck(lineConfigDialog(DevIdToInitialize, (Parent as TForm).Handle, 'comm/datamodem'));
end;

procedure TTAPILine.TranslateDialog;
Var
   lVer: DWORD;
begin
  if DevIdToInitialize = MAXDWORD Then
     raise Exception.Create ('TAPILine: You must select TAPI compatible line');

  if Version = 0 Then
     lVer := LoVer
  else
     lVer := Version;

    TapiCheck(lineTranslateDialog(LineApp, DevIdToInitialize, lVer, (Parent as TForm).Handle, PChar (PhoneNumber)));
end;

function TTAPILine.Write (const sData: String): Boolean;
Var
   buffer: PChar;
Begin
    Result := False;

    if sData = '' Then exit;

    getmem (buffer, Length (sData)+10);
    StrPCopy (buffer, sData);
    Result := WriteLargeData (buffer, Length (sData));
    freemem (buffer);
End;

procedure TTAPILine.OnConnectionInt;
Var
   lpVarString_: LPVARSTRING;
   dwSizeofVarString: DWORD;
   CommTimeOuts: TCommTimeOuts;
   dcb: TDCB;
Begin

   // Very first, make sure this isn't a duplicated message.
   // A CALLSTATE message can be sent whenever there is a
   // change to the capabilities of a line, meaning that it is
   // possible to receive multiple CONNECTED messages per call.
   // The CONNECTED CALLSTATE message is the only one in TapiComm
   // where it would cause problems if it where sent more
   // than once.
//   if (bConnected) Then
  //     exit;

   bConnected := TRUE;

   dwSizeofVarString := sizeof(VARSTRING) + 1024;
   hCommFile := 0;

   // Get the handle to the comm port from the driver so we can start
   // communicating.  This is returned in a LPVARSTRING structure.
   // Allocate the VARSTRING structure
   GetMem(LPVOID(lpVarString_), dwSizeofVarString);
   ZeroMem (PChar(lpVarString_));
   lpVarString_^.dwTotalSize:=dwSizeofVarString;

   // Fill the VARSTRING structure
   TapiCheck (lineGetID (Line, 0, Call, LINECALLSELECT_CALL,
              lpVarString_, 'comm/datamodem'));

   // Again, the handle to the comm port is contained in a
   // LPVARSTRING structure.  Thus, the handle is the very first
   // thing after the end of the structure.  Note that the name of
   // the comm port is right after the handle, but I don't want it.
   strmove (@hCommFile, PChar (LONG(lpVarString_) + lpVarString_^.dwStringOffset), sizeof (LONG));

   { We don't need to set the baud rate and other parameters
     because most of them are set up with TAPIserv}
   if (hCommFile <> INVALID_HANDLE_VALUE) then
      begin

         GetCommTimeouts(hCommFile, commtimeouts);

         // The CommTimeout numbers will very likely change if you are
         // coding to meet some kind of specification where
         // you need to reply within a certain amount of time after
         // recieving the last byte.  However,  If 1/4th of a second
         // goes by between recieving two characters, its a good
         // indication that the transmitting end has finished, even
         // assuming a 1200 baud modem.

         commtimeouts.ReadIntervalTimeout         := 250;
         commtimeouts.ReadTotalTimeoutMultiplier  := 0;
         commtimeouts.ReadTotalTimeoutConstant    := 0;
         commtimeouts.WriteTotalTimeoutMultiplier := 0;
         commtimeouts.WriteTotalTimeoutConstant   := 0;

         SetCommTimeouts(hCommFile, commtimeouts);

         // set OnNewData event
         SetCommMask (hCommFile, EV_RXCHAR);
         if Assigned (OnNewData) Then
            ResumeWaitingNewData;
      end
   else
       bConnected := False;
End;

function TTAPILine.Read(wantedToRead: DWORD):string;
Var
   buffer: PChar;
Begin

    if wantedToRead = 0 then
       wantedToRead := cbInQue;

    if wantedToRead = 0 then
       exit;

    buffer := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, wantedToRead+10);
    ReadLargeData (buffer, wantedToRead);
    SetLength (Result, wantedToRead+10);
    Result := Copy (strpas (buffer), 1, wantedToRead);
    HeapFree (GetProcessHeap, 0, buffer);
End;

procedure TTAPILine.SetPhoneNumber (value: String);
begin
    if FPhoneNumber <> value Then
       FPhoneNumber := value;
end;

procedure TTAPILine.SetDevIDToInitialize (value: DWORD);
Var
  dwAPIVersion: DWORD;
  lpLineDevCaps_:  LPLINEDEVCAPS;
begin
    if FDevIDToInitialize <> Value Then
       Begin
       if FDevIDToInitialize <> value Then
          if VerifyUsableLine (value) = 0 Then
             FDevIDToInitialize := value;

       {This routine is necessary,
         because we want to take modem name
         Let's go! }
       GetMem(LPVOID(lpLineDevCaps_), sizeof(TLINEDEVCAPS) + 1024);
       ZeroMem (PChar(lpLineDevCaps_));
       dwAPIVersion := I_lineNegotiateAPIVersion(DevIdToInitialize);
       lpLineDevCaps_^.dwTotalSize:=sizeof(TLINEDEVCAPS) + 1024;
       TapiCheck (lineGetDevCaps (LineApp, DevIdToInitialize, dwAPIVersion, 0, lpLineDevCaps_));
       formDialing.ModemName.Caption := GetLineName (lpLineDevCaps_);
       FreeMem (lpLineDevCaps_);
       End;
end;

procedure ZeroMem (p: PChar);
Var
   i: integer;
begin
    for i := 0 to sizeof (p)-1 do p[i]:= Chr (0);
End;

procedure TTAPILine.SetWaitForCall (value: boolean);
begin
    if FWaitForCall <> value Then
       FWaitForCall := value;
end;

function TTAPILine.ReadLargeData (buffer: PChar; wantedToRead: DWORD):LONG;
Var
   dwLastError: DWORD;
   overlappedRead: TOVERLAPPED;
   dwHandleSignaled, dwNumberOfBytesRead: DWORD;
   dwWhereToStartReading: DWORD;
   comstat : TCOMSTAT;
   dwErrors: DWORD;
Begin
   Result := 0;
   dwNumberOfBytesRead := 0;
   dwWhereToStartReading := 0;

   if bConnected and (hCommFile <> INVALID_HANDLE_VALUE) Then
      Begin

      ZeroMemory (buffer, wantedToRead);

      with overlappedRead do
         Begin
         Internal :=0;
         InternalHigh :=0;
         Offset :=0;
         OffsetHigh :=0;
         hEvent := eventOverlappedRead;
         End;

      if wantedToRead = 0 Then wantedToRead := cbInQue;

      if (wantedToRead <= 0) then exit;

      repeat
         // Start the overlapped I/O.
         if (not ReadFile (hCommFile, (buffer+dwWhereToStartReading)^,
	             wantedToRead, dwNumberOfBytesRead, @overlappedRead)) Then
             Begin
             // WriteFile failed.  Expected; lets handle it.
             dwLastError := GetLastError;

             // Its possible for this error to occur if the
             // service provider has closed the port.  Time to end.
             if dwLastError = ERROR_INVALID_HANDLE Then
                 Begin
                 // Likely that the Service Provider has closed the port.
                 ClearCommError (hCommFile, dwErrors, @comstat);
                 raise Exception.Create ('COM Error: '+ClearCommErrorToStr (dwErrors));
                 End;

             // Unexpected error.  No idea what.
             if dwLastError <> ERROR_IO_PENDING then
                raise Exception.Create ('Error reading from com port.');

             // This is the expected ERROR_IO_PENDING case.

             // Wait for overlapped I/O completion,
             dwHandleSignaled := WaitForSingleObject (eventOverlappedRead, Timeout*1000);

             case (dwHandleSignaled) of
                  WAIT_OBJECT_0:     // Wait finished.
                  Begin              // Time to get the results of the WriteFile
                  End;

                  WAIT_TIMEOUT:       // Wait failed.
                      Begin
                      // CancelIO (hCommFile);
                      // Really useful function, but works only under Windows NT
                      // Why?!
                      PurgeComm (hCommFile, PURGE_TXABORT+PURGE_RXABORT);
                      raise Exception.Create ('Timeout during read operation.');
                      End;

             else // This case should never occur.
                  raise Exception.Create ('Unexpected Wait return value ');
             end;

             if (not GetOverlappedResult (hCommFile, OverlappedRead,
                     dwNumberOfBytesRead, TRUE)) then
                Begin
                dwLastError := GetLastError();

                // Its possible for this error to occur if the
                // service provider has closed the port.
                if dwLastError = ERROR_INVALID_HANDLE then
                    // Likely that the Service Provider has closed the port.
                    raise Exception.Create ('Connection has been broken during read.');

                // No idea what could cause another error.
                raise Exception.Create ('Error reading from com port while waiting');
                End;
             End;

          // Some data was written.  Make sure it all got written.
          wantedToRead := wantedToRead - dwNumberOfBytesRead;
          dwWhereToStartReading := dwWhereToStartReading + dwNumberOfBytesRead;

      until (wantedToRead = 0);  // Read the whole thing!

      End;
      Result := dwWhereToStartReading;
End;

function TTAPILine.ClearCommErrorToStr (dwErrorFlags : DWORD) : string;
begin
  Result := '';

  if dwErrorFlags = CE_BREAK Then
      Result:=Result + 'The hardware detected a break condition.';

  if dwErrorFlags = CE_DNS Then
      Result:=Result + 'Windows 95 only: A parallel device is not selected.';

  if dwErrorFlags = CE_FRAME Then
      Result:=Result + 'The hardware detected a framing error.';

  if dwErrorFlags = CE_IOE Then
      Result:=Result + 'An I/O error occurred during communications with the device.';

  if dwErrorFlags = CE_MODE Then
      Result:=Result + 'The requested mode is not supported, or the hFile parameter is invalid. If this value is specified, it is the only valid error.';

  if dwErrorFlags = CE_OOP Then
      Result:=Result + 'Windows 95 only: A parallel device signaled that it is out of paper.';

  if dwErrorFlags = CE_OVERRUN Then
      Result:=Result + 'A character-buffer overrun has occurred. The next character is lost.';

  if dwErrorFlags = CE_PTO Then
      Result:=Result + 'Windows 95 only: A time-out occurred on a parallel device.';

  if dwErrorFlags = CE_RXOVER Then
      Result:=Result + 'An input buffer overflow has occurred. There is either no room in the input buffer, or a character was received after the end-of-file (EOF) character.';

  if dwErrorFlags = CE_RXPARITY Then
      Result:=Result + 'The hardware detected a parity error.';

  if dwErrorFlags = CE_TXFULL Then
      Result:=Result + 'The application tried to transmit a character, but the output buffer was full.';
End;

function TTAPILine.GetIcon (DevID: DWORD): HICON;
Begin
    Result := 0;

    if DevId = MAXDWORD Then
       DevId := DevIdToInitialize;

    if DevId = MAXDWORD Then
//       raise Exception.Create ('TAPILine: You must select TAPI compatible line');
       exit;

    TapiCheck (lineGetIcon (DevID, 'comm/datamodem', Result));
End;

function TTAPILine.Drop: boolean;
Var
   Time: DWORD;
begin

//  if Assigned (thisTAPILine.InfoLabel) Then thisTAPILine.InfoLabel.Text := 'Try to drop call... (takes several seconds)';

  Result := False;
  SetEvent (eventCallInProcess);
  bConnected := False;
  bDropped := True;

  if Call.unused <> 0 then
     begin
     dwRequestDrop := lineDrop (Call, nil, 0);
//     TapiCheck (dwRequestDrop);
     Call.unused:=0;
     end;

  while WaitForSingleObject (eventCallInProcess, EVENT_TIMEOUT) = WAIT_TIMEOUT do
         Application.ProcessMessages;

  if Assigned (FOnDropCall) Then FOnDropCall (self);
end;

procedure TTAPILine.Close;
Var
   dw: DWORD;
Begin
  if Assigned (thisTAPILine.InfoLabel) then
     thisTAPILine.InfoLabel.Text := 'Try to close line... (takes several seconds)';

   Application.ProcessMessages;
   SetEvent (eventCallInProcess);
   bConnected := False;

   if (hCommFile <> INVALID_HANDLE_VALUE) Then
      Begin
      PurgeComm (hCommFile, PURGE_TXABORT+PURGE_RXABORT);
      CloseHandle (hCommFile);
      hCommFile := INVALID_HANDLE_VALUE;
      End;

   if NumDevs <> 0 then
       Begin
       dw := lineClose (Line);
       End;

   if Assigned (FOnClose) Then FOnClose (self);
End;

procedure TTAPILine.MakeDirectAccessScript;
Var
   s, s2 : string;
   pc : PChar;
   i, limit: integer;
   waitTime : LONG;
   sResponse: string;
   slLog: TLogFile;
Begin

    if DevIdToInitialize = MAXDWORD Then
       raise Exception.Create ('TAPILine: You must select TAPI compatible line');

    slLog := nil;
    if FDirectAccessLogFile <> '' Then
       slLog := TLogFile.Create (self);

    if Assigned (slLog) Then slLog.WriteLog ('TAPILine logfile: ', DateTimeToStr (Now));

    //SetThreadPriority (GetCurrentThread, THREAD_PRIORITY_HIGHEST);
    limit := FDirectAccessScript.Count;
    Dec (limit);
    sResponse := '';
    for i := 0 to limit do
        Begin
        s := FDirectAccessScript.Strings [i];
        if Assigned (slLog) Then slLog.WriteLog ('Write (send command to modem)', s+NEW_LINE);
        Write (s+NEW_LINE);
        while not bDropped do
              Begin

              // our modem have to have time to answer...
              waitTime := GetTickCount () + 1000;
              while waitTime > GetTickCount ()do
                    Application.ProcessMessages;

              sResponse := sResponse + Read (0);
              if Assigned (slLog) Then slLog.WriteLog ('Read (command in process)', sResponse);
              if Pos ('OK', UpperCase (sResponse)) <> 0 Then
                 Begin
                 if Assigned (slLog) Then slLog.WriteLog ('Command complete (OK received)', sResponse);
                 sResponse := '';
                 if limit <> i Then
                    break; //Go to do the next command from script
                 End
              else
              if Pos ('CONNECT', UpperCase (sResponse)) <> 0 Then
                 Begin
                 // we made a connection!
                 if Assigned (slLog) Then slLog.WriteLog ('Connected! (conection esteblished)', sResponse);
                 if Assigned (slLog) Then slLog.SaveToFile (FDirectAccessLogFile);

                 slLog.Free;

                 //SetThreadPriority (GetCurrentThread, THREAD_PRIORITY_NORMAL);
                 PurgeComm (hCommFile, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);
                 exit;
                 End
              else
              if (Pos ('ERROR', UpperCase (sResponse)) <> 0) or
                 (Pos ('NO ', UpperCase (sResponse)) <> 0) Then
                 Begin
                 if Assigned (slLog) Then slLog.WriteLog ('Error (modem return bad response)', sResponse);
                 PurgeComm (hCommFile, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);
                 if Assigned (slLog) Then slLog.SaveToFile (FDirectAccessLogFile);
                 slLog.Free;
                 //SetThreadPriority (GetCurrentThread, THREAD_PRIORITY_NORMAL);

                 sDirectAccessResult := 'TAPILine: Device direct access script error: "' + s + '".'+NEW_LINE+
                                         sResponse;
                 raise Exception.Create(sDirectAccessResult);
                 End;
              Application.ProcessMessages;
              End;
        End;

    if bDropped Then
       if Assigned (slLog) Then slLog.WriteLog ('Dropped (user hangup)', sResponse);

    if slLog <> nil Then
       Begin
       slLog.SaveToFile (FDirectAccessLogFile);
       slLog.Free;
       End;

    //SetThreadPriority (GetCurrentThread, THREAD_PRIORITY_NORMAL);
End;

//
//  FUNCTION: void FillTAPILine(HWND)
//
//  PURPOSE: Fills the 'TAPI Line' control with the available line devices.
//
//  PARAMETERS:
//    hwndDlg - handle to the current "Dial" dialog
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
//    This function enumerates through all the TAPI line devices and
//    queries each for the device name.  The device name is then put into
//    the 'TAPI Line' control.  These device names are kept in order rather
//    than sorted.  This allows "Dial" to know which device ID the user
//    selected just by the knowing the index of the selected string.
//
//    There are default values if there isn't a device name, if there is
//    an error on the device, or if the device name is an empty string.
//    The device name is also checked to make sure it is null terminated.
//
//    Note that a Legacy API Version is negotiated.  Since the fields in
//    the LINEDEVCAPS structure that we are interested in haven't moved, we
//    can negotiate a lower API Version than this sample is designed for
//    and still be able to access the necessary structure members.
//
//    The first line that is usable by TapiComm is selected as the 'default'
//    line.  Also note that if there was a previously selected line, this
//    remains the default line.  This would likely only occur if this
//    function is called after the dialog has initialized once; for example,
//    if a new line is added.
//
//

function TTAPILine.FillTAPILine (sl: TStrings): DWORD;
Var
    dwDeviceID: DWORD;
    dwAPIVersion: DWORD;
    lpLineDevCaps_: LPLINEDEVCAPS;
    sLineName: string;
Begin
    Result := MAXDWORD;

    sl.Clear;

    lpLineDevCaps_ := nil;
    GetMem(LPVOID(lpLineDevCaps_), sizeof(TLINEDEVCAPS) + 1024);
    ZeroMem (PChar(lpLineDevCaps_));
    lpLineDevCaps_^.dwTotalSize:=sizeof(TLINEDEVCAPS) + 1024;

    for dwDeviceID := 0 to NumDevs-1 do
        begin
        dwAPIVersion := I_lineNegotiateLegacyAPIVersion (dwDeviceID);
        if (dwAPIVersion <> 0) Then
           Begin
           TapiCheck (lineGetDevCaps (LineApp, dwDeviceID, dwAPIVersion, 0, lpLineDevCaps_));

           sLineName := GetLineName (lpLineDevCaps_);
           End
        else  // Couldn't NegotiateAPIVersion.  Line is unavail.
            sLineName := LINEUNAVAIL;

        // Put the device name into the control
        sl.Add (sLineName);
        sLineName := '';

        // If this line is usable and we don't have a default initial
        // line yet, make this the initial line.
{        if ((strcomp (lpszLineName, LINEUNAVAIL) <> 0) and
            (Result = MAXDWORD) and
            (VerifyUsableLine (dwDeviceID) = 0)) Then
            Result := dwDeviceID;}

        End; {for dwDeviceID := 0 to dwNumDevs-1 do}

    if (lpLineDevCaps_ <> nil) then
        freemem (lpLineDevCaps_);

End;

function TTAPILine.GetLineName (lpLineDevCaps_: LPLINEDEVCAPS): string;
Var
   lpszLineName: PChar;
Begin
    GetMem(lpszLineName, 200);
    ZeroMem (lpszLineName);
    Result := '';

    if (lpLineDevCaps_ <> nil) Then
       Begin
       if ((lpLineDevCaps_^.dwLineNameSize <> 0) and
           (lpLineDevCaps_^.dwLineNameOffset <> 0) and
           (lpLineDevCaps_^.dwStringFormat = STRINGFORMAT_ASCII)) then
           Begin
           // This is the name of the device.
           getmem (lpszLineName, lpLineDevCaps_^.dwLineNameSize+1);
           strmove (lpszLineName, PChar (LONG(lpLineDevCaps_) + lpLineDevCaps_^.dwLineNameOffset),
                    lpLineDevCaps_^.dwLineNameSize);

           if (lpszLineName[0] <> Chr (0)) Then
               Begin
               // Reverse indented to make this fit

               // Make sure the device name is null terminated.
               if (lpszLineName [lpLineDevCaps_^.dwLineNameSize -1] <> Chr (0)) Then
                  Begin
                  // If the device name is not null terminated, null
                  // terminate it.  Yes, this looses the end character.
                  // Its a bug in the service provider.
                  lpszLineName[lpLineDevCaps_^.dwLineNameSize-1] := Chr (0);
                  End;
                End
           else // Line name started with a NULL.
               StrPCopy (lpszLineName, LINENAMEEMPTY);
           End
       else  // DevCaps doesn't have a valid line name.  Unnamed.
           StrPCopy (lpszLineName, LINEUNNAMED);

       Result := StrPas (lpszLineName);
       freemem (lpszLineName);
       End
    else  // Couldn't GetDevCaps.  Line is unavail.
       Result := LINEUNAVAIL;
End;

//
//  FUNCTION: DWORD I_lineNegotiateLegacyAPIVersion(DWORD)
//
//  PURPOSE: Negotiate an API Version to use for a specific device.
//
//  PARAMETERS:
//    dwDeviceID - device to negotiate an API Version for.
//
//  RETURN VALUE:
//    Returns the API Version to use for this line if successful.
//    Returns 0 if negotiations fall through.
//
//  COMMENTS:
//
//    This wrapper is slightly different from the I_lineNegotiateAPIVersion.
//    This wrapper allows TapiComm to negotiate an API version between
//    1.3 and SAMPLE_TAPI_VERSION.  Normally, this sample is specific to
//    API Version SAMPLE_TAPI_VERSION.  However, there are a few times when
//    TapiComm needs to get information from a service provider, but also knows
//    that a lower API Version would be ok.  This allows TapiComm to recognize
//    legacy service providers even though it can't use them.  1.3 is the
//    lowest API Version a legacy service provider should support.
//
//

function TTAPILine.I_lineNegotiateLegacyAPIVersion (dwDeviceID: DWORD): DWORD;
Var
  LineExtensionID: TLINEEXTENSIONID;
  dwLocalAPIVersion: DWORD;
  dwReturn: DWORD;
Begin

    dwReturn := lineNegotiateAPIVersion (LineApp, dwDeviceID,
             LoVer, HiVer, @dwLocalAPIVersion, @LineExtensionID);

    if (dwReturn = LINEERR_INCOMPATIBLEAPIVERSION) Then
       Begin
       Result := 0;
       exit;
       End;

    TapiCheck (dwReturn);
    Result := dwLocalAPIVersion;
End;

function TTAPILine.I_lineNegotiateAPIVersion (dwDeviceID: DWORD): DWORD;
Var
  LineExtensionID: TLINEEXTENSIONID;
  dwLocalAPIVersion: DWORD;
  dwReturn: DWORD;
Begin

    dwReturn := lineNegotiateAPIVersion (LineApp, dwDeviceID,
             LoVer, LoVer, @dwLocalAPIVersion, @LineExtensionID);

    if (dwReturn = LINEERR_INCOMPATIBLEAPIVERSION) Then
       Begin
       Result := 0;
       exit;
       End;

    TapiCheck (dwReturn);
    Result := dwLocalAPIVersion;
End;

//
//  FUNCTION: long VerifyUsableLine(DWORD)
//
//  PURPOSE: Verifies that a specific line device is useable by TapiComm.
//
//  PARAMETERS:
//    dwDeviceID - The ID of the line device to be verified
//
//  RETURN VALUE:
//    Returns SUCCESS if dwDeviceID is a usable line device.
//    Returns a LINENOTUSEABLE_ constant otherwise.
//
//  COMMENTS:
//
//    VerifyUsableLine takes the give device ID and verifies step by step
//    that the device supports all the features that TapiComm requires.
//
//

function TTAPILine.VerifyUsableLine (dwDeviceID: DWORD): LONG;
Var
    hLine_: HLINE;
    lpLineDevCaps_: LPLINEDEVCAPS;
    lpLineAddressStatus_: LPLINEADDRESSSTATUS;
    lpVarString_: LPVARSTRING;
    dwAPIVersion: DWORD;
    lReturn: LONG;
    hCall_ : HCALL;

Label DeleteBuffers;

Begin
    Result := 0;
    hLine_.unused := 0;
    lpLineDevCaps_ := nil;
    lpLineAddressStatus_ := nil;
    lpVarString_ := nil;

    // The line device must support an API Version that TapiComm does.
    dwAPIVersion := I_lineNegotiateAPIVersion(dwDeviceID);
    if (dwAPIVersion = 0) Then
       begin
       Result := LINENOTUSEABLE_ERROR;

       {h-mm, operator GOTO!!!}
       goto DeleteBuffers;
       End;

    lpLineDevCaps_ := nil;
    GetMem(LPVOID(lpLineDevCaps_), sizeof(TLINEDEVCAPS) + 1024);
    ZeroMem (PChar(lpLineDevCaps_));
    lpLineDevCaps_^.dwTotalSize:=sizeof(TLINEDEVCAPS) + 1024;

    TapiCheck (lineGetDevCaps (LineApp, dwDeviceID, dwAPIVersion, 0, lpLineDevCaps_));

    // Must support LINEBEARERMODE_VOICE
    if ((lpLineDevCaps_^.dwBearerModes and LINEBEARERMODE_VOICE) = 0) then
       Begin
       Result := LINENOTUSEABLE_NOVOICE;
       ShowMessage ('VerifyUsableLine: doesn''t support LINEBEARERMODE_VOICE');
       goto DeleteBuffers;
       End;

    // Must support LINEMEDIAMODE_DATAMODEM
    if ((lpLineDevCaps_^.dwMediaModes and LINEMEDIAMODE_DATAMODEM) = 0) then
       Begin
       Result := LINENOTUSEABLE_NODATAMODEM;
       ShowMessage ('VerifyUsableLine: doesn''t support LINEMEDIAMODE_DATAMODEM');
       goto DeleteBuffers;
       End;

    // Must be able to make calls
    if ((lpLineDevCaps_^.dwLineFeatures and LINEFEATURE_MAKECALL) = 0) Then
       Begin
       Result := LINENOTUSEABLE_NOMAKECALL;
       ShowMessage ('VerifyUsableLine: doesn''t support LINEFEATURE_MAKECALL');
       goto DeleteBuffers;
       End;

    // It is necessary to open the line so we can check if
    // there are any call appearances available.  Other TAPI
    // applications could be using all call appearances.
    // Opening the line also checks for other possible problems.

    lReturn := lineOpen(LineApp, dwDeviceID, @hLine_,
            dwAPIVersion, 0, 0,
            LINECALLPRIVILEGE_NONE, LINEMEDIAMODE_DATAMODEM,
            LPLINECALLPARAMS(0));

    if (lReturn = LINEERR_ALLOCATED) Then
       Begin
       ShowMessage ('VerifyUsableLine: ' +NEW_LINE+
                    'Line is already in use by a non-TAPI app or' +NEW_LINE+
                    'another Service Provider.');
       Result := LINENOTUSEABLE_ALLOCATED;
       goto DeleteBuffers;
       End
    else
       Tapicheck (lReturn);

    lpLineAddressStatus_ := nil;
    GetMem(LPVOID(lpLineAddressStatus_), sizeof(TLINEADDRESSSTATUS) + 1024);
    ZeroMem (PChar(lpLineAddressStatus_));
    lpLineAddressStatus_^.dwTotalSize:=sizeof(TLINEADDRESSSTATUS) + 1024;

    // Get LineAddressStatus to make sure the line isn't already in use.
    TapiCheck (lineGetAddressStatus(hLine_, 0, lpLineAddressStatus_));

    // Are there any available call appearances (ie: is it in use)?
    if ( (lpLineAddressStatus_^.dwAddressFeatures and
               LINEADDRFEATURE_MAKECALL) = 0) Then
       Begin
       ShowMessage ('VerifyUsableLine: ' +NEW_LINE+
                    'Line make call feature is not available.');
       Result := LINENOTUSEABLE_INUSE;
       goto DeleteBuffers;
       End;

    // Make sure the "comm/datamodem" device class is supported
    // Note that we don't want any of the 'extra' information
    // normally returned in the VARSTRING structure.  All we care
    // about is if lineGetID succeeds.

    {GetMem(LPVOID(lpVarString_), sizeof(VARSTRING) + 1024);
    ZeroMem (PChar(lpVarString_));
    lpVarString_^.dwTotalSize:=sizeof(VARSTRING) + 1024;

    // Fill the VARSTRING structure
    TapiCheck (lineGetID (hLine_, 0, hCall_, LINECALLSELECT_LINE,
              lpVarString_, 'comm/datamodem'));
     }
    DeleteBuffers:

    if (hCall_.unused <> 0) then
        lineDrop (hCall_, nil, 0);
    if (hLine_.unused <> 0) then
        lineClose (hLine_);
    if (lpLineAddressStatus_ <> nil) then
        Freemem (lpLineAddressStatus_);
    if (lpLineDevCaps_ <> nil) Then
        Freemem (lpLineDevCaps_);
    if (lpVarString_ <> nil) then
        Freemem(lpVarString_);

End;

procedure TTAPILine.SetLines(Value: TStrings);
begin
    if Value <> nil Then
       FDirectAccessScript.Assign(Value);
end;

procedure TTAPILine.SetInfoLabel(Value: TStatusPanel);
begin
//    if Value <> nil Then
  //     FInfoLabel.Assign(Value);
end;

function TTAPILine.cbInQue:longint;
Var
   ComStat: TCOMSTAT;
   dwErrorFlags: DWORD;
Begin
   if bConnected Then
      Begin
      ComStat.cbInQue := 0;
      dwErrorFlags := 0;
      ClearCommError (hCommFile, dwErrorFlags, @ComStat);
      Result := ComStat.cbInQue;
      if Result > 1000 Then
         raise Exception.Create ('It seems that ClearCommError function failed.'+#13+
               'Or you try to get more than 1000 kB.');
      End;
End;

procedure TTAPILine.SetTimeout (Value: longint);
Var
   commtimeouts: TCommtimeouts;
begin
    if Value <> FTimeout Then
       begin
       GetCommTimeouts(hCommFile, commtimeouts);

       // The CommTimeout numbers will very likely change if you are
       // coding to meet some kind of specification where
       // you need to reply within a certain amount of time after
       // recieving the last byte.  However,  If 1/4th of a second
       // goes by between recieving two characters, its a good
       // indication that the transmitting end has finished, even
       // assuming a 1200 baud modem.

       commtimeouts.ReadIntervalTimeout         := -1;
       commtimeouts.ReadTotalTimeoutMultiplier  := -1;
       commtimeouts.ReadTotalTimeoutConstant    := Value;
       commtimeouts.WriteTotalTimeoutMultiplier := 0;
       commtimeouts.WriteTotalTimeoutConstant   := 0;

       SetCommTimeouts(hCommFile, commtimeouts);
       end;
end;

procedure TformDialing.bHangUpClick(Sender: TObject);
begin
    try
       thisTAPILine.Drop;
    except
    end;
    formDialing.Hide;
end;

function TTAPILine.WriteLargeData (const buffer: PChar; wantedToWrite: DWORD): Boolean;
Var
    ComStat: TCOMSTAT;
    dwLastError: DWORD;
    dwNumberOfBytesWritten: DWORD;
    overlappedWrite: TOVERLAPPED;
    dwWhereToStartWriting: DWORD;
    dwHandleSignaled: DWORD;
    dwCharsWritten: DWORD;
    dwErrors: DWORD;
Begin
    Result := False;
    if (bConnected) and (hCommFile <> INVALID_HANDLE_VALUE) Then
       Begin
       with overlappedWrite do
         Begin
         Internal :=0;
         InternalHigh :=0;
         Offset :=0;
         OffsetHigh :=0;
         hEvent := eventOverlappedWrite;
         End;

       dwNumberOfBytesWritten := 0;
       dwWhereToStartWriting := 0; // Start at the beginning.

       // Keep looping until all characters have been written.
       repeat
            // Start the overlapped I/O.
            if (not WriteFile(hCommFile, (buffer+dwWhereToStartWriting)^,
                wantedToWrite, dwNumberOfBytesWritten, @overlappedWrite)) Then
                Begin
                // WriteFile failed.  Expected; lets handle it.
                dwLastError := GetLastError;

                // Its possible for this error to occur if the
                // service provider has closed the port.  Time to end.
                if dwLastError = ERROR_INVALID_HANDLE Then
                   Begin
                   // Likely that the Service Provider has closed the port.
                   ClearCommError (hCommFile, dwErrors, @comstat);
                   raise Exception.Create ('COM Error: '+ClearCommErrorToStr (dwErrors));
                   End;

                // Unexpected error.  No idea what.
                if dwLastError <> ERROR_IO_PENDING then
                   raise Exception.Create ('Error to writing to com port.');

                // This is the expected ERROR_IO_PENDING case.

                // Wait for overlapped I/O completion,
                dwHandleSignaled := WaitForSingleObject (eventOverlappedWrite, Timeout*1000);

                case (dwHandleSignaled) of
                     WAIT_OBJECT_0:     // Wait finished.
                         Begin          // Time to get the results of the WriteFile
                         End;

                     WAIT_TIMEOUT:       // Wait failed.
                         Begin
//                         CancelIO (hCommFile);
                         PurgeComm (hCommFile, PURGE_TXABORT+PURGE_RXABORT);
                         raise Exception.Create ('Timeout during write operation.');
                         End;

                else // This case should never occur.
                     raise Exception.Create ('Unexpected Wait return value ');
                end;

                if (not GetOverlappedResult (hCommFile, OverlappedWrite,
                     dwNumberOfBytesWritten, TRUE)) then
                     Begin
                     dwLastError := GetLastError();

                     // Its possible for this error to occur if the
                     // service provider has closed the port.
                     if dwLastError = ERROR_INVALID_HANDLE then
                        // Likely that the Service Provider has closed the port.
                        raise Exception.Create ('Connection has been broken during write.');

                     // No idea what could cause another error.
                     raise Exception.Create ('Error writing to com port while waiting');
                     End;
                End;

          // Some data was written.  Make sure it all got written.
          wantedToWrite := wantedToWrite - dwNumberOfBytesWritten;
          dwWhereToStartWriting := dwWhereToStartWriting + dwNumberOfBytesWritten;

      until (wantedToWrite = 0);  // Write the whole thing!

      // Wrote the whole string.
      Result := True;
    End;
End;

procedure TformDialing.CMNewData (var Message: TMessage);
Begin
    Thread := TNewData.Create (False);
    Thread.FreeOnTerminate := True;
end;

procedure TformDialing.CMNewDataArrives (var Message: TMessage);
Begin
    if not thisTAPILine.bStopWaitingNewData Then
       if Assigned (thisTAPILine.OnNewData) Then thisTAPILine.OnNewData (self);
End;

procedure TTAPILine.ResumeWaitingNewData;
Begin
   if bConnected and (Thread = nil) Then
      Begin
      bStopWaitingNewData := False;
      PostMessage (formDialing.handle, CM_NEWDATATHREAD, 0, 0);
      End;
End;

{ TNewData }

procedure TNewData.Execute;
Var
   eventOverlappedWait: THandle;
   overlappedWait: TOVERLAPPED;
   dwHandleSignaled: DWORD;
   dwEvent: DWORD;
   dwNumberOfBytesWritten: DWORD;
   dwLastError: DWORD;
   s: string;
   stat: TCOMSTAT;
Begin
    if bWaitingInProcess Then exit;

    dwEvent := 0;
    eventOverlappedWait := CreateEvent (nil, True, True, nil);

    with overlappedWait do
         Begin
         Internal :=0;
         InternalHigh :=0;
         Offset :=0;
         OffsetHigh :=0;
         hEvent := eventOverlappedWait;
         End;

    ResetEvent (eventOverlappedWait);

    while (thisTAPILine.bConnected) and (thisTAPILine.hCommFile <> INVALID_HANDLE_VALUE) and
          (not thisTAPILine.bStopWaitingNewData) do
           Begin

           // Keep looping until EV_RXCHAR arrives...

           Application.ProcessMessages;

           // Start the overlapped I/O.
           if not WaitCommEvent (thisTAPILine.hCommFile, dwEvent, @overlappedWait) Then
              Begin
                // Wait for overlapped I/O completion,
                dwHandleSignaled := WaitForSingleObject (eventOverlappedWait, 1000);

                case (dwHandleSignaled) of
                     WAIT_OBJECT_0:     // Wait finished.
                         Begin          // Time to get the results of the WaitCommEvent
//                         lfLog.WriteLog ('WaitForSingleObject == TRUE', 'New data');
                         PostMessage (formDialing.handle, CM_NEWDATAARRIVES, 0, 0);
                         dwEvent := 0;
                         End;

                     WAIT_TIMEOUT:       // Wait failed.
                         Begin
                         End;
                end;

                if (not GetOverlappedResult (thisTAPILine.hCommFile, OverlappedWait,
                     dwNumberOfBytesWritten, False)) then
                     Begin
                     dwLastError := GetLastError();

                     if dwLastError <> ERROR_IO_INCOMPLETE Then
                        Begin
                        // Its possible for this error to occur if the
                        // service provider has closed the port.
                        if dwLastError = ERROR_INVALID_HANDLE then
                           exit;
                           // Likely that the Service Provider has closed the port.
                           //raise Exception.Create ('Connection has been broken waiting for COM port event.');

                           // No idea what could cause another error.
                           exit;
//                        raise Exception.Create ('Error waiting for COM port event');
                        End;
                     End
                else
                    Begin
//                    lfLog.WriteLog ('GetOverlappedResult == TRUE', 'New data');
                    PostMessage (formDialing.handle, CM_NEWDATAARRIVES, 0, 0);
                    End;

                    {for some strange reason EV_RXCHAR arrives two times.
                     That is why I have to dispatch it one time at least.}
              End
           else
              begin
              PostMessage (formDialing.handle, CM_NEWDATAARRIVES, 0, 0);
//              lfLog.WriteLog ('WaitCommEvent == TRUE', 'New data');
              end;
       end;

    CloseHandle (eventOverlappedWait);

    Thread := nil;
End;

{ TLogFile }

constructor TLogFile.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);

    slLogFile := TStringList.Create;
    slLogFile.Clear;
end;

destructor TLogFile.Destroy;
begin
    slLogFile.Free;

    inherited Destroy;
end;

procedure TLogFile.WriteLog (tag: string; responce: string);
Begin
    if responce <> '' Then
      slLogFile.Add (DateTimeToStr (Now) + ' - '+ tag + ': '+responce)
    else
      slLogFile.Add (DateTimeToStr (Now) + ' - '+ tag);
End;

procedure TLogFile.SaveToFile (sfile: string);
Begin
    slLogFile.SaveToFile (sfile);
End;

end.

